Index: src/Filling/Filler.cpp
===================================================================
--- src/Filling/Filler.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Filler.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,148 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Filler.cpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <algorithm>
+#include <boost/bind.hpp>
+#include <boost/lambda/lambda.hpp>
+#include <sstream>
+#include <vector>
+
+#include "Filler.hpp"
+
+#include "CodePatterns/Assert.hpp"
+#include "CodePatterns/Log.hpp"
+
+#include "Atom/atom.hpp"
+#include "Box.hpp"
+#include "ClusterInterface.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Inserter/Inserter.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "NodeTypes.hpp"
+#include "Predicates/FillPredicate.hpp"
+#include "Predicates/Ops_FillPredicate.hpp"
+#include "World.hpp"
+
+
+/** Constructor for class Filler.
+ *
+ * \note We store inverted \a _predicate because we need it only for
+ * remove_copy_if which works in this inverted way as desired.
+ *
+ * @param _mesh Mesh with a NodeSet that fills its Shape
+ * @param _predicate predicate construct to check at each Node
+ * @param _inserter inserter which places the cloned cluster
+ */
+Filler::Filler(const Mesh &_mesh, const FillPredicate &_predicate, const Inserter &_inserter) :
+  mesh(_mesh),
+  predicate(!_predicate),
+  inserter(_inserter)
+{}
+
+/** Destructor for class Filler.
+ *
+ */
+Filler::~Filler()
+{}
+
+/** Fill in the desired Cluster at each remaining node.
+ *
+ * \note The cluster is non-const because it is moved to the first vacant node.
+ *
+ * @param copyMethod functor that knows how to copy atoms.
+ * @param cluster set of atomic ids contained in a specific Shape to fill each Node with
+ * @return true - at least one node has been filled, false - no node filled
+ */
+bool Filler::operator()(
+    CopyAtomsInterface &copyMethod,
+    ClusterInterface::Cluster_impl cluster) const
+{
+  const NodeSet &nodes = mesh.getNodes();
+  std::stringstream output;
+  std::for_each( nodes.begin(), nodes.end(), output << boost::lambda::_1 << " ");
+  LOG(3, "DEBUG: Listing nodes to check: " << output.str());
+  if (nodes.size() == 0)
+    return false;
+  NodeSet FillNodes(nodes.size(), zeroVec);
+
+  // move filler cluster's atoms out of domain such that it does not disturb the predicate.
+  // we only move the atoms as otherwise two translate ShapeOps will be on top of the Shape
+  // which is subsequently copied to all other cloned Clusters ...
+  Vector BoxDiagonal;
+  {
+    const RealSpaceMatrix &M = World::getInstance().getDomain().getM();
+    BoxDiagonal = (M * Vector(1.,1.,1.));
+    BoxDiagonal -= cluster->getShape().getCenter();
+    BoxDiagonal *= 1. + 2.*cluster->getShape().getRadius()/BoxDiagonal.Norm(); // extend it a little further
+    AtomIdSet atoms = cluster->getAtoms();
+    for (AtomIdSet::iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
+      (*iter)->setPosition( (*iter)->getPosition() + BoxDiagonal );
+    LOG(1, "INFO: Translating original cluster's atoms by " << BoxDiagonal << ".");
+  }
+
+  // evaluate predicate and gather into new set
+  NodeSet::iterator transform_end  =
+      std::remove_copy_if(nodes.begin(), nodes.end(), FillNodes.begin(), predicate );
+  FillNodes.erase(transform_end, FillNodes.end());
+
+  // shift cluster back to original place
+  {
+    AtomIdSet atoms = cluster->getAtoms();
+    for (AtomIdSet::iterator iter = atoms.begin(); iter != atoms.end(); ++iter)
+      (*iter)->setPosition( (*iter)->getPosition() - BoxDiagonal );
+    LOG(1, "INFO: Translating original cluster's atoms back.");
+  }
+
+  if (FillNodes.size() == 0) {
+    ELOG(2, "For none of the nodes did the predicate return true.");
+    return false;
+  } else {
+    LOG(1, "INFO: " << FillNodes.size() << " out of " << nodes.size() << " returned true from predicate.");
+  }
+
+  // clone clusters
+  std::vector<ClusterInterface::Cluster_impl> clusters(FillNodes.size());
+  std::vector<ClusterInterface::Cluster_impl>::iterator clusteriter = clusters.begin();
+  *clusteriter = cluster;
+  clusteriter++;
+  std::generate_n(clusteriter, FillNodes.size()-1,
+      boost::bind(&ClusterInterface::clone, boost::cref(cluster), boost::ref(copyMethod), zeroVec) );
+
+  // insert each cluster by abusing std::search a bit:
+  // we look for the subsequence of FillNodes inside clusters. If Inserter always
+  // returns true, we'll have the iterator pointing at first cluster
+  std::vector<ClusterInterface::Cluster_impl>::const_iterator inserteriter =
+    std::search(clusters.begin(), clusters.end(), FillNodes.begin(), FillNodes.end(),
+        boost::bind(&Inserter::operator(), boost::cref(inserter), _1, _2));
+  if( inserteriter != clusters.begin()) {
+    ELOG(1, "Not all cloned clusters could be successfully inserted.");
+    return false;
+  }
+
+  // give final statment on whether at least \a single cluster has been placed
+  if ( FillNodes.size() != 0)
+    return true;
+  else
+    return false;
+}
+
Index: src/Filling/Filler.hpp
===================================================================
--- src/Filling/Filler.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Filler.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,49 @@
+/*
+ * Filler.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLER_HPP_
+#define FILLER_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Cluster.hpp"
+#include "Predicates/FillPredicate.hpp"
+#include "Mesh/Mesh.hpp"
+#include "NodeTypes.hpp"
+
+class CopyAtomsInterface;
+class FillPredicate;
+class Inserter;
+class Mesh;
+
+/** This class operators on a set of nodes (Vector's), checks which fulfill some
+ * given predicate, and fills these position with a given molecule lateron.
+ *
+ */
+class Filler
+{
+public:
+  Filler(const Mesh &_mesh, const FillPredicate &_predicate, const Inserter &_inserter);
+  ~Filler();
+
+  bool operator()(CopyAtomsInterface &copyMethod, ClusterInterface::Cluster_impl cluster) const;
+
+private:
+  //!> mesh is the set of points filling a Shape
+  const Mesh mesh;
+  //!> the predicate is evaluted whether a Node in the NodeSet of mesh is filled or not
+  const FillPredicate predicate;
+  //!> Inserter function to allow for some changes when placing the cluster at the node
+  const Inserter &inserter;
+};
+
+
+#endif /* FILLER_HPP_ */
Index: src/Filling/Generators/NodeGenerator.cpp
===================================================================
--- src/Filling/Generators/NodeGenerator.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Generators/NodeGenerator.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,113 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * NodeGenerator.cpp
+ *
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "NodeGenerator.hpp"
+
+#include <cmath>
+#include <vector>
+
+#include "Shapes/Shape.hpp"
+#include "Shapes/ShapeOps.hpp"
+
+/** Constructor for NodeGenerator.
+ *
+ * @param _shape Shape which is to be filled with nodes
+ */
+NodeGenerator::NodeGenerator(const Shape &_shape) :
+	shape(_shape)
+{}
+
+/** Destructor for NodeGenerator.
+ *
+ */
+NodeGenerator::~NodeGenerator()
+{}
+
+/** Returns a set of points contained in the \a NodeGenerator::_shape
+ * with a homogeneous density.
+ *
+ * The central idea of the algorithm is to make use of the present function
+ * for obtaining homogeneously distributed points on all surfaces of
+ * presently implemented Shape's.
+ *
+ * The given \a _shape is shrinked such that eventually the volume is filled
+ * with points. Points filled in that actually reside outside the given
+ * Shape are eventually extracted as all are checked for inclusion.
+ *
+ * \note Although a certain density of points given as it has to be converted
+ * to an discrete regime this density can in general be matched only
+ * approximately.
+ *
+ * @param density desired density of points, the unit is the inverse of the
+ * required volume per point
+ * @return set of nodes
+ */
+NodeSet  NodeGenerator::operator()(const double density)
+{
+	// calculate volume and surface of the given Shape
+	const double volume = shape.getVolume();
+	const double surface = shape.getSurfaceArea();
+
+	// calculate the number of shrinking operations
+	const double radius = shape.getRadius();
+	const double fraction = surface/volume;
+	const int factor = floor(radius * fraction);
+
+	// calculate correction for surface density due to discrete number of layers
+	const double surfaceDensity = volume/(double)factor;
+
+	// fill the shrinking vector
+	std::vector<double> shrinking_factors;
+	for(int f=0; f < factor; ++f)
+		shrinking_factors.push_back(radius*((double)f/(double)factor));
+
+	// go through the shrinking operations
+	NodeSet nodes;
+	for (std::vector<double>::const_iterator iter = shrinking_factors.begin();
+			iter != shrinking_factors.end(); ++iter) {
+		const Shape currentShape = resize(shape, *iter);
+		std::vector<Vector> pointsOnSurface =
+				currentShape.getHomogeneousPointsOnSurface(surfaceDensity);
+		nodes.insert(nodes.end(), pointsOnSurface.begin(), pointsOnSurface.end());
+	}
+
+	// check each point whether its inside the surface
+	return filterOutsidePoints(nodes);
+}
+
+/** Filters out all points that are not contained inside NodeGenerator::shape.
+ *
+ * @param nodes nodes to check
+ * @return subset of nodes that fulfill Shape::isInisde().
+ */
+NodeSet NodeGenerator::filterOutsidePoints(const NodeSet &nodes) const
+{
+	NodeSet return_nodes;
+	return_nodes.reserve(nodes.size());
+	for (NodeSet::const_iterator iter = nodes.begin(); iter != nodes.end(); ++iter) {
+		if (shape.isInside(*iter))
+			return_nodes.push_back(*iter);
+	}
+
+	return return_nodes;
+}
Index: src/Filling/Generators/NodeGenerator.hpp
===================================================================
--- src/Filling/Generators/NodeGenerator.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Generators/NodeGenerator.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,42 @@
+/*
+ * NodeGenerator.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef NODEGENERATOR_HPP_
+#define NODEGENERATOR_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/NodeTypes.hpp"
+
+#include "Shapes/Shape.hpp"
+
+/** The class NodeGenerator is an interface to routines that generate points
+ * within a domain used for subsequent traversal and test as possible filling
+ * positions.
+ *
+ */
+class NodeGenerator
+{
+public:
+
+  NodeGenerator(const Shape &_shape);
+  ~NodeGenerator();
+
+  NodeSet operator()(const double density);
+
+private:
+  NodeSet filterOutsidePoints(const NodeSet &nodes) const;
+
+  Shape shape;
+};
+
+
+#endif /* NODEGENERATOR_HPP_ */
Index: src/Filling/Inserter/Inserter.cpp
===================================================================
--- src/Filling/Inserter/Inserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/Inserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,55 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Inserter.cpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Inserter.hpp"
+
+#include "InserterBase.hpp"
+
+/** Constructor for class Inserter.
+ *
+ * @param _impl implementation to wrap
+ */
+Inserter::Inserter(Inserter::impl_ptr _impl) :
+    impl(_impl)
+{}
+
+/** Copy Constructor for class Inserter.
+ *
+ */
+Inserter::Inserter(const Inserter &ptr) :
+    impl(ptr.getImpl())
+{}
+
+/** Destructor for class Inserter.
+ *
+ */
+Inserter::~Inserter()
+{}
+
+bool Inserter::operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const
+{
+  return impl->operator()(cluster, offset);
+}
+
+Inserter::impl_ptr Inserter::getImpl() const {
+  return impl;
+}
Index: src/Filling/Inserter/Inserter.hpp
===================================================================
--- src/Filling/Inserter/Inserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/Inserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,51 @@
+/*
+ * Inserter.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef INSERTER_HPP_
+#define INSERTER_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <boost/shared_ptr.hpp>
+
+#include "Filling/ClusterInterface.hpp"
+
+class Vector;
+
+class InserterBase;
+
+/** This class defines the interface for all derived classes.
+ *
+ * This is just a functor of an inserter function.
+ *
+ */
+class Inserter
+{
+public:
+  typedef boost::shared_ptr<InserterBase> impl_ptr;
+  friend impl_ptr getInserterImpl(const Inserter&);
+
+  Inserter(const Inserter &ptr);
+  Inserter(impl_ptr);
+  ~Inserter();
+  bool operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const;
+
+protected:
+  impl_ptr getImpl() const;
+
+private:
+  impl_ptr impl;
+};
+
+Inserter::impl_ptr getInserterImpl(const Inserter &f);
+
+
+#endif /* INSERTER_HPP_ */
Index: src/Filling/Inserter/InserterBase.hpp
===================================================================
--- src/Filling/Inserter/InserterBase.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/InserterBase.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,35 @@
+/*
+ * InserterBase.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef INSERTERBASE_HPP_
+#define INSERTERBASE_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/ClusterInterface.hpp"
+
+class Vector;
+
+/** Inserter defines the interface to all classes that handle insertion of \a
+ * Cluster into the World at a specific position.
+ */
+class InserterBase
+{
+public:
+  InserterBase() {}
+  virtual ~InserterBase() {}
+
+  virtual bool operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const = 0;
+
+};
+
+
+#endif /* INSERTERBASE_HPP_ */
Index: src/Filling/Inserter/RandomInserter.cpp
===================================================================
--- src/Filling/Inserter/RandomInserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/RandomInserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,220 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * RandomInserter.cpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "RandomInserter.hpp"
+
+#include <algorithm>
+
+#include "Atom/atom.hpp"
+#include "CodePatterns/Log.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "RandomNumbers/RandomNumberGeneratorFactory.hpp"
+#include "RandomNumbers/RandomNumberGenerator.hpp"
+
+
+size_t RandomInserter::Max_Attempts = 10;
+
+/** Sets given 3x3 matrix to a random rotation matrix.
+ *
+ * @param a matrix to set
+ */
+inline void setRandomRotation(RealSpaceMatrix &a)
+{
+  double phi[NDIM];
+  RandomNumberGenerator &random = RandomNumberGeneratorFactory::getInstance().makeRandomNumberGenerator();
+  const double rng_min = random.min();
+  const double rng_max = random.max();
+
+  for (int i=0;i<NDIM;i++) {
+    phi[i] = (random()/(rng_max-rng_min))*(2.*M_PI);
+    LOG(4, "DEBUG: Random angle is " << phi[i] << ".");
+  }
+
+  a.setRotation(phi);
+}
+
+/** Constructor for class RandomInserter.
+ *
+ * @param _MaxAtomComponent maximum component for random atom translations
+ * @param _MaxMoleculeComponent maximum component for random molecule translations
+ * @param  _DoRandomRotation whether to do random rotations
+ */
+RandomInserter::RandomInserter(
+    const double _MaxAtomComponent,
+    const double _MaxMoleculeComponent,
+    const bool _DoRandomRotation) :
+   random(RandomNumberGeneratorFactory::getInstance().makeRandomNumberGenerator()),
+   rng_min(random.min()),
+   rng_max(random.max()),
+   MaxAtomComponent(_MaxAtomComponent),
+   MaxMoleculeComponent(_MaxMoleculeComponent),
+   DoRandomRotation(_DoRandomRotation)
+{}
+
+/** Destructor for class RandomInserter.
+ *
+ */
+RandomInserter::~RandomInserter()
+{}
+
+/** Checks whether all atoms currently are inside the cluster's shape.
+ *
+ * @param cluster cluster to check
+ * @return true - all atoms are inside cluster's shape, false - else
+ */
+bool RandomInserter::AreClustersAtomsInside(ClusterInterface::Cluster_impl cluster) const
+{
+  ClusterInterface::atomIdSet atoms = cluster->getAtomIds();
+  bool status = true;
+
+  for (ClusterInterface::atomIdSet::const_iterator iter = atoms.begin();
+      iter != atoms.end();
+      ++iter)
+    status = status && cluster->isInside(*iter);
+
+  return status;
+}
+
+/** Perform the given random translations and rotations on a cluster.
+ *
+ * @param cluster cluster to translate and rotate
+ * @param Rotations random rotation matrix
+ * @param RandomAtomTranslations vector with random translation for each atom in cluster
+ * @param RandomMoleculeTranslation vector with random translation for cluster
+ * @param offset vector with offset for cluster
+ */
+void RandomInserter::doTranslation(
+    ClusterInterface::Cluster_impl cluster,
+    const RealSpaceMatrix &Rotations,
+    const std::vector<Vector> &RandomAtomTranslations,
+    const Vector &RandomMoleculeTranslation) const
+{
+  AtomIdSet atoms = cluster->getAtoms();
+
+  ASSERT( atoms.size() <=  RandomAtomTranslations.size(),
+      "RandomInserter::doTranslation() - insufficient random atom translations given.");
+
+  cluster->transform(Rotations);
+  cluster->translate(RandomMoleculeTranslation);
+  AtomIdSet::iterator miter = atoms.begin();
+  std::vector<Vector>::const_iterator aiter = RandomAtomTranslations.begin();
+  for(;miter != atoms.end(); ++miter, ++aiter)
+    (*miter)->setPosition((*miter)->getPosition() + *aiter);
+}
+
+/** Undos a given random translations and rotations on a cluster.
+ *
+ * @param cluster cluster to translate and rotate
+ * @param Rotations random rotation matrix
+ * @param RandomAtomTranslations vector with random translation for each atom in cluster
+ * @param RandomMoleculeTranslations vector with random translation for cluster
+ * @param offset vector with offset for cluster
+ */
+void RandomInserter::undoTranslation(
+    ClusterInterface::Cluster_impl cluster,
+    const RealSpaceMatrix &Rotations,
+    const std::vector<Vector> &RandomAtomTranslations,
+    const Vector &RandomMoleculeTranslation) const
+{
+  AtomIdSet atoms = cluster->getAtoms();
+  ASSERT( atoms.size() <=  RandomAtomTranslations.size(),
+      "RandomInserter::doTranslation() - insufficient random atom translations given.");
+
+  // get inverse rotation
+  RealSpaceMatrix inverseRotations = Rotations.invert();
+
+  AtomIdSet::iterator miter = atoms.begin();
+  std::vector<Vector>::const_iterator aiter = RandomAtomTranslations.begin();
+  for(;miter != atoms.end(); ++miter, ++aiter) {
+    (*miter)->setPosition((*miter)->getPosition() - *aiter);
+  }
+  cluster->translate(zeroVec-RandomMoleculeTranslation);
+  cluster->transform(inverseRotations);
+}
+
+/** Creates a random vector
+ *
+ * @param range range of components, i.e. \f$ v[i] \in [0,range)\f$
+ * @param offset offset for each component
+ * @return \a range * rnd() + \a offset
+ */
+Vector RandomInserter::getRandomVector(const double range, const double offset) const
+{
+  Vector returnVector;
+  for (size_t i=0; i<NDIM; ++i)
+    returnVector[i] = (range*random()/((rng_max-rng_min)/2.)) + offset;
+  return returnVector;
+}
+
+/** Inserter operator that randomly translates and rotates the Cluster.
+ *
+ * \note we assume that clusters are always cloned at origin.
+ *
+ * @param offset
+ * @return true - random translations and rotations did not violate bounding shape, false - else
+ */
+bool RandomInserter::operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const
+{
+  // calculate center
+  AtomIdSet atoms = cluster->getAtoms();
+  Vector center;
+  center.Zero();
+  for(AtomIdSet::iterator miter = atoms.begin();miter != atoms.end(); ++miter)
+    center += (*miter)->getPosition();
+  center *= 1./atoms.size();
+
+  // shift cluster to center
+  cluster->translate(zeroVec-center);
+
+  size_t attempt = 0;
+  for (;attempt < Max_Attempts; ++attempt) {
+    // generate random rotation matrix
+    RealSpaceMatrix Rotations;
+    if (DoRandomRotation)
+      setRandomRotation(Rotations);
+    else
+      Rotations.setIdentity();
+
+    // generate random molecule translation vector
+    Vector RandomMoleculeTranslation(getRandomVector(MaxMoleculeComponent, -MaxMoleculeComponent));
+
+    // generate random atom translation vector
+    std::vector<Vector> RandomAtomTranslations(atoms.size(), zeroVec);
+    std::generate_n(RandomAtomTranslations.begin(), atoms.size(),
+        boost::bind(&RandomInserter::getRandomVector, boost::cref(this), MaxAtomComponent, -MaxAtomComponent));
+
+    // apply!
+    doTranslation(cluster, Rotations, RandomAtomTranslations, RandomMoleculeTranslation);
+
+    // ... and check
+    if (!AreClustersAtomsInside(cluster)) {
+      undoTranslation(cluster, Rotations, RandomAtomTranslations, RandomMoleculeTranslation);
+    } else {
+      break;
+    }
+  }
+
+  // and move to final position
+  cluster->translate(offset+center);
+
+  return attempt != Max_Attempts;
+}
Index: src/Filling/Inserter/RandomInserter.hpp
===================================================================
--- src/Filling/Inserter/RandomInserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/RandomInserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,77 @@
+/*
+ * RandomInserter.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef RANDOMINSERTER_HPP_
+#define RANDOMINSERTER_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "InserterBase.hpp"
+
+#include <vector>
+
+#include "LinearAlgebra/Vector.hpp"
+
+class RandomNumberGenerator;
+class RealSpaceMatrix;
+
+/** RandomInserter implements Inserter interface such that the given \a Cluster
+ * is inserted at the position with a slight random variation.
+ *
+ * \warning As the RandomInserter rotates the molecule, the only bounding shape in
+ * Cluster that makes sense is a sphere. Otherwise, RandomInserter::Max_Attempts
+ * attempts are made at finding a lucky shot where all atoms, though rotated
+ * and randomly translated, remain inside but after that the cluster is inserted
+ * as it is.
+ */
+class RandomInserter : public InserterBase
+{
+public:
+  RandomInserter(const double _MaxAtomComponent, const double _MaxMoleculeComponent, const bool _DoRandomRotation);
+  ~RandomInserter();
+
+  bool operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const;
+
+private:
+  bool AreClustersAtomsInside(ClusterInterface::Cluster_impl cluster) const;
+  Vector getRandomVector(const double range, const double offset) const;
+
+  void doTranslation(
+      ClusterInterface::Cluster_impl cluster,
+      const RealSpaceMatrix &Rotations,
+      const std::vector<Vector> &RandomAtomTranslations,
+      const Vector &RandomMoleculeTranslations) const;
+  void undoTranslation(
+      ClusterInterface::Cluster_impl cluster,
+      const RealSpaceMatrix &Rotations,
+      const std::vector<Vector> &RandomAtomTranslations,
+      const Vector &RandomMoleculeTranslations) const;
+
+private:
+  //!> internal random number generator
+  RandomNumberGenerator &random;
+  //!> minimum value of the random number distribution
+  const double rng_min;
+  //!> maximum value of the random number distribution
+  const double rng_max;
+  //!> range is maximum component for atom translations
+  const double MaxAtomComponent;
+  //!> range is maximum component for molecule translations
+  const double MaxMoleculeComponent;
+  //!> whether to randomly rotate or not
+  const bool DoRandomRotation;
+
+  //!> maximum number of tries to find a suitable randomized position
+  static size_t Max_Attempts;
+};
+
+
+#endif /* RANDOMINSERTER_HPP_ */
Index: src/Filling/Inserter/SimpleInserter.cpp
===================================================================
--- src/Filling/Inserter/SimpleInserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/SimpleInserter.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,47 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * SimpleInserter.cpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "SimpleInserter.hpp"
+
+/** Constructor for class SimpleInserter.
+ *
+ */
+SimpleInserter::SimpleInserter()
+{}
+
+/** Destructor for class SimpleInserter.
+ *
+ */
+SimpleInserter::~SimpleInserter()
+{}
+
+/** Inserter operator that simply enacts ClusterInterface::clone().
+ *
+ * @param offset
+ * @return always true
+ */
+bool SimpleInserter::operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const
+{
+  cluster->translate(offset);
+
+  return true;
+}
Index: src/Filling/Inserter/SimpleInserter.hpp
===================================================================
--- src/Filling/Inserter/SimpleInserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Inserter/SimpleInserter.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,33 @@
+/*
+ * SimpleInserter.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef SIMPLEINSERTER_HPP_
+#define SIMPLEINSERTER_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/Inserter/InserterBase.hpp"
+
+/** SimpleInserter implements Inserter interface such that the given \a Cluster
+ * is simply inserted at the given position.
+ */
+class SimpleInserter : public InserterBase
+{
+public:
+  SimpleInserter();
+  ~SimpleInserter();
+
+  bool operator()(ClusterInterface::Cluster_impl cluster, const Vector &offset) const;
+};
+
+
+
+#endif /* SIMPLEINSERTER_HPP_ */
